
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef hueblob_ERROR_H
#define hueblob_ERROR_H

#include "h2errorLib.h"
#include "genom/genomError.h"

#define M_hueblob    (6002)

/* -- MODULES ERRORS -------------------------------------------------- */

/* demo errors */
#define S_hueblob_STEREO               H2_ENCODE_ERR(M_hueblob   , 1)
#define S_hueblob_NOT_STEREO_BANK      H2_ENCODE_ERR(M_hueblob   , 2)
#define S_hueblob_NO_MODEL             H2_ENCODE_ERR(M_hueblob   , 3)
#define S_hueblob_NOT_FOUND            H2_ENCODE_ERR(M_hueblob   , 4)
#define S_hueblob_NEED_COLOR_IMAGE     H2_ENCODE_ERR(M_hueblob   , 5)
#define S_hueblob_BAD_IMAGE            H2_ENCODE_ERR(M_hueblob   , 6)
#define S_hueblob_LOW_MEMORY           H2_ENCODE_ERR(M_hueblob   , 7)
#define S_hueblob_IMAGE_UNREADABLE     H2_ENCODE_ERR(M_hueblob   , 8)
#define S_hueblob_NO_SUCH_FILE         H2_ENCODE_ERR(M_hueblob   , 9)


/* std errors */
#define S_hueblob_stdGenoM_ACTIVITY_INTERRUPTED       393405441   /* 6002<<16 | 0x8000 | 100<<8 | 1 */
#define S_hueblob_stdGenoM_TOO_MANY_ACTIVITIES        393405442   /* 6002<<16 | 0x8000 | 100<<8 | 2 */
#define S_hueblob_stdGenoM_ACTIVITY_FAILED            393405443   /* 6002<<16 | 0x8000 | 100<<8 | 3 */
#define S_hueblob_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY 393405444   /* 6002<<16 | 0x8000 | 100<<8 | 4 */
#define S_hueblob_stdGenoM_UNKNOWN_ACTIVITY           393405445   /* 6002<<16 | 0x8000 | 100<<8 | 5 */
#define S_hueblob_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION 393405446   /* 6002<<16 | 0x8000 | 100<<8 | 6 */
#define S_hueblob_stdGenoM_SYSTEM_ERROR               393405447   /* 6002<<16 | 0x8000 | 100<<8 | 7 */
#define S_hueblob_stdGenoM_ACTIVITY_ALREADY_ENDED     393405448   /* 6002<<16 | 0x8000 | 100<<8 | 8 */
#define S_hueblob_stdGenoM_WAIT_INIT_RQST             393405449   /* 6002<<16 | 0x8000 | 100<<8 | 9 */
#define S_hueblob_stdGenoM_CONTROL_CODEL_ERROR        393405450   /* 6002<<16 | 0x8000 | 100<<8 | 10 */
#define S_hueblob_stdGenoM_EXEC_TASK_SUSPENDED        393405451   /* 6002<<16 | 0x8000 | 100<<8 | 11 */
#define S_hueblob_stdGenoM_BAD_BLOCK_TYPE             393405452   /* 6002<<16 | 0x8000 | 100<<8 | 12 */
#define S_hueblob_stdGenoM_BAD_POSTER_TYPE            393405453   /* 6002<<16 | 0x8000 | 100<<8 | 13 */



/* static H2_ERROR[] */
#define HUEBLOB_H2_ERR_MSGS {\
    {"STEREO", 1},\
    {"NOT_STEREO_BANK", 2},\
    {"NO_MODEL", 3},\
    {"NOT_FOUND", 4},\
    {"NEED_COLOR_IMAGE", 5},\
    {"BAD_IMAGE", 6},\
    {"LOW_MEMORY", 7},\
    {"IMAGE_UNREADABLE", 8},\
    {"NO_SUCH_FILE", 9},\
}

#ifdef __cplusplus
extern "C" {
#endif

extern int hueblobRecordH2errMsgs(void);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
