
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef HUEBLOB_PRINT_H
#define HUEBLOB_PRINT_H

#include "genom/printScan.h"

/* Structures definies par d'autres modules */

#include "server/stereopixelPrint.h"

#include "server/viamPrint.h"

#include "server/pomPrint.h"


#include "hueblobPosterLib.h"

/* Prototypes */
#ifdef __cplusplus
extern "C" {
#endif
extern void print_struct_HUEBLOB_BLOB_POSTER_STR ( FILE *out,
     struct HUEBLOB_BLOB_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_HueBlobIds ( FILE *out,
     struct HueBlobIds *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_HueBlobTrackChessboard ( FILE *out,
     struct HueBlobTrackChessboard *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_HueBlobTrackBlob ( FILE *out,
     struct HueBlobTrackBlob *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_HueBlobBox ( FILE *out,
     struct HueBlobBox *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_HueBlob3DBox ( FILE *out,
     struct HueBlob3DBox *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_HueBlob3DPoint ( FILE *out,
     struct HueBlob3DPoint *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_HueBlobImageBox ( FILE *out,
     struct HueBlobImageBox *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_HueBlobInput ( FILE *out,
     struct HueBlobInput *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_HueBlobObject ( FILE *out,
     struct HueBlobObject *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_enum_HueBlobBool ( FILE *out,
     enum HueBlobBool *x,
     int indent, int nDim, int *dims, FILE *in );

/* ======================== PRINT DES TYPEDEF ============================= */

extern void print_HueBlobBool ( FILE *out,
     HueBlobBool *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_HueBlobObject ( FILE *out,
     HueBlobObject *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_HueBlobInput ( FILE *out,
     HueBlobInput *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_HueBlobImageBox ( FILE *out,
     HueBlobImageBox *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_HueBlob3DPoint ( FILE *out,
     HueBlob3DPoint *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_HueBlob3DBox ( FILE *out,
     HueBlob3DBox *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_HueBlobBox ( FILE *out,
     HueBlobBox *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_HueBlobTrackBlob ( FILE *out,
     HueBlobTrackBlob *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_HueBlobTrackChessboard ( FILE *out,
     HueBlobTrackChessboard *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_HueBlobIds ( FILE *out,
     HueBlobIds *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_HUEBLOB_BLOB_POSTER_STR ( FILE *out,
     HUEBLOB_BLOB_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
#ifdef __cplusplus
}
#endif

#endif /* HUEBLOB_PRINT_H */

