
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] hueblobInstall] >= 0 } {
    interp expose {} hueblobInstall
}

proc ::hueblobInstall { name } {
    foreach rqst { "Display" "StopLoop" "SetParams" "SetObject" "SetImage" "GetBox" "GetBoxLoop" "TrackBlob" "TrackChessBoard" "BlobboxPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} hueblob$rqst $name
    }
}

interp hide {} hueblobInstall




# Display ----------------------------------------------------------

if { [lsearch [interp hidden] hueblobDisplay] >= 0 } {
    interp expose {} hueblobDisplay
}
if { [lsearch [interp hidden] hueblobDisplayFormatOutput] >= 0 } {
    interp expose {} hueblobDisplayFormatOutput
}

proc ::hueblobDisplay { name args } {
    set format {}
    lappend format [list { "HUEBLOB_ENABLE" "HUEBLOB_DISABLE" } "Display state" "HUEBLOB_ENABLE" ]

    return [ ::cs::rqstSend "${name}" "Display" \
	"Control embedded display facility" \
	"HueBlobBool display\n" \
	1 \
	$format \
	$args ]
}


proc ::hueblobDisplayFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} hueblobDisplay
interp hide {} hueblobDisplayFormatOutput





# StopLoop ----------------------------------------------------------

if { [lsearch [interp hidden] hueblobStopLoop] >= 0 } {
    interp expose {} hueblobStopLoop
}
if { [lsearch [interp hidden] hueblobStopLoopFormatOutput] >= 0 } {
    interp expose {} hueblobStopLoopFormatOutput
}

proc ::hueblobStopLoop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopLoop" \
	"Interrupt tracking loops" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::hueblobStopLoopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} hueblobStopLoop
interp hide {} hueblobStopLoopFormatOutput





# SetParams ----------------------------------------------------------

if { [lsearch [interp hidden] hueblobSetParams] >= 0 } {
    interp expose {} hueblobSetParams
}
if { [lsearch [interp hidden] hueblobSetParamsFormatOutput] >= 0 } {
    interp expose {} hueblobSetParamsFormatOutput
}

proc ::hueblobSetParams { name args } {
    set format {}
    lappend format [list int "Matching threshold" 75 ]

    return [ ::cs::rqstSend "${name}" "SetParams" \
	"Set matching parameters" \
	"int threshold\n" \
	1 \
	$format \
	$args ]
}


proc ::hueblobSetParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} hueblobSetParams
interp hide {} hueblobSetParamsFormatOutput





# SetObject ----------------------------------------------------------

if { [lsearch [interp hidden] hueblobSetObject] >= 0 } {
    interp expose {} hueblobSetObject
}
if { [lsearch [interp hidden] hueblobSetObjectFormatOutput] >= 0 } {
    interp expose {} hueblobSetObjectFormatOutput
}

proc ::hueblobSetObject { name args } {
    set format {}
    lappend format [list string "Object name" "" ]
    lappend format [list string "Template image file name" "" ]
    lappend format [list double "X offset of anchor point (main frame)" 0.000000 ]
    lappend format [list double "Y offset of anchor point (main frame)" 0.000000 ]
    lappend format [list double "Z offset of anchor point (main frame)" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "SetObject" \
	"Read object template from image" \
	"HueBlobObject\n| char object\[256\]\n| char file\[256\]\n| double anchor_x\n| double anchor_y\n| double anchor_z\n" \
	5 \
	$format \
	$args ]
}


proc ::hueblobSetObjectFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} hueblobSetObject
interp hide {} hueblobSetObjectFormatOutput





# SetImage ----------------------------------------------------------

if { [lsearch [interp hidden] hueblobSetImage] >= 0 } {
    interp expose {} hueblobSetImage
}
if { [lsearch [interp hidden] hueblobSetImageFormatOutput] >= 0 } {
    interp expose {} hueblobSetImageFormatOutput
}

proc ::hueblobSetImage { name args } {
    set format {}
    lappend format [list string "Image bank" "" ]
    lappend format [list string "Camera name" "" ]
    lappend format [list { "HUEBLOB_ENABLE" "HUEBLOB_DISABLE" } "Use stereopixel 3D image" "HUEBLOB_ENABLE" ]

    return [ ::cs::rqstSend "${name}" "SetImage" \
	"Set image source and size" \
	"HueBlobInput\n| char bank\[256\]\n| char camera\[256\]\n| HueBlobBool use3d\n" \
	3 \
	$format \
	$args ]
}


proc ::hueblobSetImageFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} hueblobSetImage
interp hide {} hueblobSetImageFormatOutput





# GetBox ----------------------------------------------------------

if { [lsearch [interp hidden] hueblobGetBox] >= 0 } {
    interp expose {} hueblobGetBox
}
if { [lsearch [interp hidden] hueblobGetBoxFormatOutput] >= 0 } {
    interp expose {} hueblobGetBoxFormatOutput
}

proc ::hueblobGetBox { name args } {
    set format {}
    lappend format [list string "Object name" "" ]
    lappend format [list int "unused" 0 ]
    lappend format [list int "X sub-image coord (or -1 for full image)" -1 ]
    lappend format [list int "Y sub-image coord (or -1)" -1 ]
    lappend format [list int "DX sub-image size (or -1)" -1 ]
    lappend format [list int "DY sub-image size (or -1)" -1 ]

    return [ ::cs::rqstSend "${name}" "GetBox" \
	"Get new image and find object position" \
	"HueBlobImageBox\n| char object\[256\]\n| int nIter\n| int x\n| int y\n| int width\n| int height\n" \
	6 \
	$format \
	$args ]
}


proc ::hueblobGetBoxFormatOutput { list } {
    set format { {} status { } { box { } { video { } object { } nIter { } x { } y { } width { } height } { } { space { } { center { } x { } y { } z } { } { min { } x { } y { } z } { } { max { } x { } y { } z } } { } { absolute_space { } { center { } x { } y { } z } { } { min { } x { } y { } z } { } { max { } x { } y { } z } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} hueblobGetBox
interp hide {} hueblobGetBoxFormatOutput





# GetBoxLoop ----------------------------------------------------------

if { [lsearch [interp hidden] hueblobGetBoxLoop] >= 0 } {
    interp expose {} hueblobGetBoxLoop
}
if { [lsearch [interp hidden] hueblobGetBoxLoopFormatOutput] >= 0 } {
    interp expose {} hueblobGetBoxLoopFormatOutput
}

proc ::hueblobGetBoxLoop { name args } {
    set format {}
    lappend format [list string "Object name" "" ]
    lappend format [list int "Number of loops" 3 ]
    lappend format [list int "X sub-image coord (or -1 for full image)" -1 ]
    lappend format [list int "Y sub-image coord (or -1)" -1 ]
    lappend format [list int "DX sub-image size (or -1)" -1 ]
    lappend format [list int "DY sub-image size (or -1)" -1 ]

    return [ ::cs::rqstSend "${name}" "GetBoxLoop" \
	"Get new image and find object position" \
	"HueBlobImageBox\n| char object\[256\]\n| int nIter\n| int x\n| int y\n| int width\n| int height\n" \
	6 \
	$format \
	$args ]
}


proc ::hueblobGetBoxLoopFormatOutput { list } {
    set format { {} status { } { box { } { video { } object { } nIter { } x { } y { } width { } height } { } { space { } { center { } x { } y { } z } { } { min { } x { } y { } z } { } { max { } x { } y { } z } } { } { absolute_space { } { center { } x { } y { } z } { } { min { } x { } y { } z } { } { max { } x { } y { } z } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} hueblobGetBoxLoop
interp hide {} hueblobGetBoxLoopFormatOutput





# TrackBlob ----------------------------------------------------------

if { [lsearch [interp hidden] hueblobTrackBlob] >= 0 } {
    interp expose {} hueblobTrackBlob
}
if { [lsearch [interp hidden] hueblobTrackBlobFormatOutput] >= 0 } {
    interp expose {} hueblobTrackBlobFormatOutput
}

proc ::hueblobTrackBlob { name args } {
    set format {}
    lappend format [list string "Stereo image bank" "" ]
    lappend format [list string "Object name" "" ]
    lappend format [list int "Initial location hint x" -1 ]
    lappend format [list int "Initial location hint y" -1 ]
    lappend format [list int "Initial location hint width" -1 ]
    lappend format [list int "Initial location hint height" -1 ]
    lappend format [list string "Output poster name" "blob" ]
    lappend format [list { "HUEBLOB_ENABLE" "HUEBLOB_DISABLE" } "Visual feedback" "HUEBLOB_ENABLE" ]

    return [ ::cs::rqstSend "${name}" "TrackBlob" \
	"Locate blob in stereo pairs and compute 3D coordinates" \
	"HueBlobTrackBlob\n| char bank\[256\]\n| char object\[256\]\n| int x\n| int y\n| int width\n| int height\n| char name\[256\]\n| HueBlobBool feedback\n" \
	8 \
	$format \
	$args ]
}


proc ::hueblobTrackBlobFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} hueblobTrackBlob
interp hide {} hueblobTrackBlobFormatOutput





# TrackChessBoard ----------------------------------------------------------

if { [lsearch [interp hidden] hueblobTrackChessBoard] >= 0 } {
    interp expose {} hueblobTrackChessBoard
}
if { [lsearch [interp hidden] hueblobTrackChessBoardFormatOutput] >= 0 } {
    interp expose {} hueblobTrackChessBoardFormatOutput
}

proc ::hueblobTrackChessBoard { name args } {
    set format {}
    lappend format [list string "Stereo image bank" "" ]
    lappend format [list int "Number of columns of the chessboard" 0 ]
    lappend format [list int "Number of rows of the chessboard" 0 ]
    lappend format [list string "Output poster name" "chessboard" ]
    lappend format [list { "HUEBLOB_ENABLE" "HUEBLOB_DISABLE" } "Visual feedback" "HUEBLOB_ENABLE" ]

    return [ ::cs::rqstSend "${name}" "TrackChessBoard" \
	"Locate chessboard in stereo pairs and compute 3D coordinates" \
	"HueBlobTrackChessboard\n| char bank\[256\]\n| int cols\n| int rows\n| char name\[256\]\n| HueBlobBool feedback\n" \
	5 \
	$format \
	$args ]
}


proc ::hueblobTrackChessBoardFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} hueblobTrackChessBoard
interp hide {} hueblobTrackChessBoardFormatOutput





# Blobbox ----------------------------------------------------------

if { [lsearch [interp hidden] hueblobBlobboxPosterRead] >= 0 } {
    interp expose {} hueblobBlobboxPosterRead
}
if { [lsearch [interp hidden] hueblobBlobboxPosterFormatOutput] >= 0 } {
    interp expose {} hueblobBlobboxPosterFormatOutput
}

proc ::hueblobBlobboxPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Blobbox" \
	"HueBlobBox\n| HueBlobImageBox\n| | char object\[256\]\n| | int nIter\n| | int x\n| | int y\n| | int width\n| | int height\n| HueBlob3DBox\n| | HueBlob3DPoint\n| | | double x\n| | | double y\n| | | double z\n| | HueBlob3DPoint\n| | | double x\n| | | double y\n| | | double z\n| | HueBlob3DPoint\n| | | double x\n| | | double y\n| | | double z\n| HueBlob3DBox\n| | HueBlob3DPoint\n| | | double x\n| | | double y\n| | | double z\n| | HueBlob3DPoint\n| | | double x\n| | | double y\n| | | double z\n| | HueBlob3DPoint\n| | | double x\n| | | double y\n| | | double z\n" \
	$args ]
}


proc ::hueblobBlobboxPosterFormatOutput { list } {
    set format { {} status { } { box { } { video { } object { } nIter { } x { } y { } width { } height } { } { space { } { center { } x { } y { } z } { } { min { } x { } y { } z } { } { max { } x { } y { } z } } { } { absolute_space { } { center { } x { } y { } z } { } { min { } x { } y { } z } { } { max { } x { } y { } z } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} hueblobBlobboxPosterRead
interp hide {} hueblobBlobboxPosterFormatOutput


